> ## Documentation Index
> Fetch the complete documentation index at: https://docs.extole.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update a trigger

> Updates the trigger. The request trigger type must match the stored trigger.



## OpenAPI

````yaml /api-reference/management.json put /v6/jobs/{jobId}/triggers/{triggerId}
openapi: 3.0.1
info:
  description: >-
    Configuration endpoints for the Extole platform: campaigns, components,
    audiences, persons, rewards, reporting, integrations setup, and
    administrative tooling.
  title: Management API
  version: '1.0'
servers:
  - description: Production
    url: https://api.extole.io
security:
  - HEADER: []
  - QUERY: []
  - COOKIE: []
tags:
  - name: Audiences
  - name: Authentication
  - name: Batch Jobs
  - name: Blocks
  - name: Campaigns
  - name: Components
  - name: Components Operations
  - name: Components Settings
  - name: Domains
  - name: Email
  - name: Erasure
  - name: Event Streams
  - name: File Validation Monitors
  - name: Optout
  - name: Profiles
  - name: Promotion Links
  - name: Report Schedules
  - name: Report Types
  - name: Reports
  - name: Reward Suppliers
  - name: Security Keys
  - name: Settings
  - name: User Notifications
  - name: User Subscriptions
  - name: Users
  - name: Webhooks
paths:
  /v6/jobs/{jobId}/triggers/{triggerId}:
    put:
      tags:
        - File Validation Monitors
      summary: Update a trigger
      description: >-
        Updates the trigger. The request trigger type must match the stored
        trigger.
      operationId: updateTrigger
      parameters:
        - description: >-
            The unique identifier of the job that owns the trigger. Use the
            reserved value `unattached` to address triggers that are not
            attached to any job, which happens when a component defines a
            trigger whose `parent_job_id` expression evaluates to nothing.
          in: path
          name: jobId
          required: true
          schema:
            type: string
        - in: path
          name: triggerId
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            example:
              component_ids:
                - component_id
              component_references:
                - component_id: component_id
                  socket_names:
                    - socket_name
              match_type: EXACT
              parent_job_id: parent_job_id
              pattern: pattern
              trigger_type: FILE_NAME_MATCHES
            schema:
              $ref: '#/components/schemas/TriggerRequest'
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TriggerResponse'
          description: Successful response
        '400':
          content:
            application/json:
              examples:
                binding_error:
                  $ref: '#/components/examples/binding_error'
                campaign_component_absolute_name_missing:
                  $ref: >-
                    #/components/examples/campaign_component_absolute_name_missing
                campaign_component_description_out_of_range:
                  $ref: >-
                    #/components/examples/campaign_component_description_out_of_range
                campaign_component_display_name_contains_illegal_character:
                  $ref: >-
                    #/components/examples/campaign_component_display_name_contains_illegal_character
                campaign_component_display_name_out_of_range:
                  $ref: >-
                    #/components/examples/campaign_component_display_name_out_of_range
                campaign_component_id_missing:
                  $ref: '#/components/examples/campaign_component_id_missing'
                campaign_component_name_already_in_use:
                  $ref: '#/components/examples/campaign_component_name_already_in_use'
                campaign_component_name_contains_illegal_character:
                  $ref: >-
                    #/components/examples/campaign_component_name_contains_illegal_character
                campaign_component_name_out_of_range:
                  $ref: '#/components/examples/campaign_component_name_out_of_range'
                campaign_component_type_validation_failed:
                  $ref: >-
                    #/components/examples/campaign_component_type_validation_failed
                circular_component_reference:
                  $ref: '#/components/examples/circular_component_reference'
                client_key_name_already_in_use:
                  $ref: '#/components/examples/client_key_name_already_in_use'
                component_facets_not_found:
                  $ref: '#/components/examples/component_facets_not_found'
                component_ids_and_references_both_provided:
                  $ref: >-
                    #/components/examples/component_ids_and_references_both_provided
                component_operation_name_already_in_use:
                  $ref: >-
                    #/components/examples/component_operation_name_already_in_use
                component_operation_name_contains_illegal_character:
                  $ref: >-
                    #/components/examples/component_operation_name_contains_illegal_character
                component_operation_name_missing:
                  $ref: '#/components/examples/component_operation_name_missing'
                component_operation_name_out_of_range:
                  $ref: '#/components/examples/component_operation_name_out_of_range'
                component_operation_name_reserved:
                  $ref: '#/components/examples/component_operation_name_reserved'
                excessive_component_reference:
                  $ref: '#/components/examples/excessive_component_reference'
                external_element_is_referenced_by_active_configuration:
                  $ref: >-
                    #/components/examples/external_element_is_referenced_by_active_configuration
                external_elements_cannot_have_multiple_references:
                  $ref: >-
                    #/components/examples/external_elements_cannot_have_multiple_references
                file_name_matches_match_type_required:
                  $ref: '#/components/examples/file_name_matches_match_type_required'
                file_name_matches_pattern_invalid_regex:
                  $ref: >-
                    #/components/examples/file_name_matches_pattern_invalid_regex
                file_name_matches_pattern_required:
                  $ref: '#/components/examples/file_name_matches_pattern_required'
                invalid_component_installed_into_socket:
                  $ref: >-
                    #/components/examples/invalid_component_installed_into_socket
                invalid_component_reference:
                  $ref: '#/components/examples/invalid_component_reference'
                invalid_component_reference_socket_name:
                  $ref: >-
                    #/components/examples/invalid_component_reference_socket_name
                invalid_external_component_reference:
                  $ref: '#/components/examples/invalid_external_component_reference'
                invalid_json:
                  $ref: '#/components/examples/invalid_json'
                invalid_null:
                  $ref: '#/components/examples/invalid_null'
                invalid_parameter:
                  $ref: '#/components/examples/invalid_parameter'
                lands_in_directory_path_required:
                  $ref: '#/components/examples/lands_in_directory_path_required'
                missing_request_body:
                  $ref: '#/components/examples/missing_request_body'
                orphan_external_component_reference:
                  $ref: '#/components/examples/orphan_external_component_reference'
                redundant_component_reference:
                  $ref: '#/components/examples/redundant_component_reference'
                self_component_reference:
                  $ref: '#/components/examples/self_component_reference'
                trigger_evaluation_failed:
                  $ref: '#/components/examples/trigger_evaluation_failed'
                trigger_parent_job_id_mismatch:
                  $ref: '#/components/examples/trigger_parent_job_id_mismatch'
                trigger_type_mismatch:
                  $ref: '#/components/examples/trigger_type_mismatch'
                trigger_type_required:
                  $ref: '#/components/examples/trigger_type_required'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Bad Request
        '401':
          content:
            application/json:
              examples:
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unauthorized
        '402':
          content:
            application/json:
              examples:
                payment_required:
                  $ref: '#/components/examples/payment_required'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Payment Required
        '403':
          content:
            application/json:
              examples:
                access_denied:
                  $ref: '#/components/examples/access_denied'
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
                missing_access_token:
                  $ref: '#/components/examples/missing_access_token'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Forbidden
        '415':
          content:
            application/json:
              examples:
                unsupported_media_type:
                  $ref: '#/components/examples/unsupported_media_type'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unsupported Media Type
        '429':
          content:
            application/json:
              examples:
                too_many_requests:
                  $ref: '#/components/examples/too_many_requests'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Too Many Requests
components:
  schemas:
    TriggerRequest:
      discriminator:
        mapping:
          FILE_NAME_MATCHES:
            $ref: '#/components/schemas/FileNameMatchesTriggerRequest'
          LANDS_IN_DIRECTORY:
            $ref: '#/components/schemas/LandsInDirectoryTriggerRequest'
        propertyName: trigger_type
      oneOf:
        - $ref: '#/components/schemas/FileNameMatchesTriggerRequest'
        - $ref: '#/components/schemas/LandsInDirectoryTriggerRequest'
      required:
        - trigger_type
    TriggerResponse:
      discriminator:
        mapping:
          FILE_NAME_MATCHES:
            $ref: '#/components/schemas/FileNameMatchesTriggerResponse'
          LANDS_IN_DIRECTORY:
            $ref: '#/components/schemas/LandsInDirectoryTriggerResponse'
        propertyName: trigger_type
      oneOf:
        - $ref: '#/components/schemas/FileNameMatchesTriggerResponse'
        - $ref: '#/components/schemas/LandsInDirectoryTriggerResponse'
      required:
        - component_ids
        - component_references
        - id
        - parent_job_id
        - trigger_type
    RestExceptionResponse:
      description: Represents the API error response
      properties:
        code:
          description: Specific error code for this error type, documented per endpoint
          type: string
        http_status_code:
          description: >-
            HTTP status code that was returned with this error, useful if client
            get response code
          format: int32
          type: integer
        message:
          description: User readable English description of the error
          type: string
        parameters:
          additionalProperties:
            description: >-
              Attributes related to the error, varies be error code, documented
              per endpoint
            type: object
          description: >-
            Attributes related to the error, varies be error code, documented
            per endpoint
          type: object
        unique_id:
          description: >-
            Unique id associated with this error, useful for discussions with
            Extole
          type: string
      required:
        - code
        - http_status_code
        - message
        - parameters
        - unique_id
      type: object
    FileNameMatchesTriggerRequest:
      allOf:
        - $ref: '#/components/schemas/TriggerRequestBase'
        - properties:
            match_type:
              $ref: '#/components/schemas/MatchTypeInFileNameMatchesTriggerRequest'
            pattern:
              $ref: '#/components/schemas/PatternInFileNameMatchesTriggerRequest'
            trigger_type:
              enum:
                - FILE_NAME_MATCHES
              type: string
          type: object
      required:
        - match_type
        - pattern
        - trigger_type
      type: object
    LandsInDirectoryTriggerRequest:
      allOf:
        - $ref: '#/components/schemas/TriggerRequestBase'
        - properties:
            directory_path:
              $ref: >-
                #/components/schemas/DirectoryPathInLandsInDirectoryTriggerRequest
            trigger_type:
              enum:
                - LANDS_IN_DIRECTORY
              type: string
          type: object
      required:
        - directory_path
        - trigger_type
      type: object
    FileNameMatchesTriggerResponse:
      allOf:
        - $ref: '#/components/schemas/TriggerResponseBase'
        - properties:
            match_type:
              $ref: '#/components/schemas/MatchTypeInFileNameMatchesTriggerResponse'
            pattern:
              $ref: '#/components/schemas/PatternInFileNameMatchesTriggerResponse'
            trigger_type:
              enum:
                - FILE_NAME_MATCHES
              type: string
          type: object
      description: >-
        Stored file name matches trigger definition. Fields `match_type` and
        `pattern` are unevaluated and appear in buildtime-evaluatable form.
      required:
        - component_ids
        - component_references
        - id
        - match_type
        - parent_job_id
        - pattern
        - trigger_type
      type: object
    LandsInDirectoryTriggerResponse:
      allOf:
        - $ref: '#/components/schemas/TriggerResponseBase'
        - properties:
            directory_path:
              $ref: >-
                #/components/schemas/DirectoryPathInLandsInDirectoryTriggerResponse
            trigger_type:
              enum:
                - LANDS_IN_DIRECTORY
              type: string
          type: object
      description: >-
        Stored lands in directory trigger definition. Field `directory_path` is
        unevaluated and appears in buildtime-evaluatable form.
      required:
        - component_ids
        - component_references
        - directory_path
        - id
        - parent_job_id
        - trigger_type
      type: object
    TriggerRequestBase:
      properties:
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceRequest'
          type: array
        parent_job_id:
          $ref: '#/components/schemas/ParentJobIdInTriggerRequest'
        trigger_type:
          enum:
            - FILE_NAME_MATCHES
            - LANDS_IN_DIRECTORY
          type: string
      type: object
    MatchTypeInFileNameMatchesTriggerRequest:
      description: >-
        How the pattern is matched against filenames. A literal value or a
        buildtime expression resolved from component references when the trigger
        is saved. Buildtime expressions use
        [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
      externalDocs:
        description: JobBuildtimeContext
        url: >-
          https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
      oneOf:
        - description: Static match type
          enum:
            - EXACT
            - REGEX
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{matchType}}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('matchType');}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    PatternInFileNameMatchesTriggerRequest:
      description: >-
        Filename pattern to match. A literal value or a buildtime expression
        resolved from component references when the trigger is saved. Buildtime
        expressions use
        [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
      externalDocs:
        description: JobBuildtimeContext
        url: >-
          https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Static pattern
          title: Static Value
        - description: >-
            Handlebars expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{pattern}}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('pattern');}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    DirectoryPathInLandsInDirectoryTriggerRequest:
      description: >-
        Directory path prefix to match. A literal value or a buildtime
        expression resolved from component references when the trigger is saved.
        Buildtime expressions use
        [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
      externalDocs:
        description: JobBuildtimeContext
        url: >-
          https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Static directory path
          title: Static Value
        - description: >-
            Handlebars expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{directoryPath}}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('directoryPath');}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    TriggerResponseBase:
      properties:
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        id:
          description: Unique id of the trigger.
          readOnly: true
          type: string
        parent_job_id:
          $ref: '#/components/schemas/ParentJobIdInTriggerResponse'
        trigger_type:
          enum:
            - FILE_NAME_MATCHES
            - LANDS_IN_DIRECTORY
          type: string
      type: object
    MatchTypeInFileNameMatchesTriggerResponse:
      description: >-
        How the pattern is matched against filenames. A literal value or a
        buildtime expression resolved from component references when the trigger
        is saved. Buildtime expressions use
        [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
      externalDocs:
        description: JobBuildtimeContext
        url: >-
          https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
      oneOf:
        - description: Literal match type
          enum:
            - EXACT
            - REGEX
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{matchType}}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('matchType');}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    PatternInFileNameMatchesTriggerResponse:
      description: >-
        Filename pattern to match. A literal value or a buildtime expression
        resolved from component references when the trigger is saved. Buildtime
        expressions use
        [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
      externalDocs:
        description: JobBuildtimeContext
        url: >-
          https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Literal pattern
          title: Static Value
        - description: >-
            Handlebars expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{pattern}}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('pattern');}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    DirectoryPathInLandsInDirectoryTriggerResponse:
      description: >-
        Directory path prefix to match. A literal value or a buildtime
        expression resolved from component references when the trigger is saved.
        Buildtime expressions use
        [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
      externalDocs:
        description: JobBuildtimeContext
        url: >-
          https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Literal directory path
          title: Static Value
        - description: >-
            Handlebars expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{directoryPath}}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('directoryPath');}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    ComponentReferenceRequest:
      properties:
        component_id:
          type: string
        socket_names:
          items:
            type: string
          type: array
      type: object
    ParentJobIdInTriggerRequest:
      description: >-
        Id of the job this trigger belongs to. A literal job id or a buildtime
        expression resolved from component references when the trigger is saved;
        when omitted the trigger belongs to the job in the request path.
        Buildtime expressions use
        [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
      externalDocs:
        description: JobBuildtimeContext
        url: >-
          https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
      oneOf:
        - description: Static parent job id
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{parentJobId}}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('parentJobId');}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    ComponentReferenceResponse:
      properties:
        component_id:
          type: string
        socket_names:
          items:
            type: string
          type: array
      type: object
    ParentJobIdInTriggerResponse:
      description: >-
        Id of the job this trigger belongs to, as the buildtime expression or
        literal that was saved. Buildtime expressions use
        [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
      externalDocs:
        description: JobBuildtimeContext
        url: >-
          https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
      oneOf:
        - description: Literal parent job id
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{parentJobId}}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [JobBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('parentJobId');}
          externalDocs:
            description: JobBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/jobs/built/JobBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
  examples:
    binding_error:
      summary: binding_error
      value:
        code: binding_error
        http_status_code: 400
        message: Argument is not of the expected type
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_component_absolute_name_missing:
      summary: campaign_component_absolute_name_missing
      value:
        code: campaign_component_absolute_name_missing
        http_status_code: 400
        message: Campaign component absolute name is missing
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_component_description_out_of_range:
      summary: campaign_component_description_out_of_range
      value:
        code: campaign_component_description_out_of_range
        http_status_code: 400
        message: Campaign component description length is out of range
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_component_display_name_contains_illegal_character:
      summary: campaign_component_display_name_contains_illegal_character
      value:
        code: campaign_component_display_name_contains_illegal_character
        http_status_code: 400
        message: >-
          Campaign component display name can only contain alphanumeric, dash,
          underscore, whitespace, asterisk, hash, dollar characters
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_component_display_name_out_of_range:
      summary: campaign_component_display_name_out_of_range
      value:
        code: campaign_component_display_name_out_of_range
        http_status_code: 400
        message: Campaign component display name length is out of range
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_component_id_missing:
      summary: campaign_component_id_missing
      value:
        code: campaign_component_id_missing
        http_status_code: 400
        message: Campaign component id is missing
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_component_name_already_in_use:
      summary: campaign_component_name_already_in_use
      value:
        code: campaign_component_name_already_in_use
        http_status_code: 400
        message: Campaign component name is already used by another component
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_component_name_contains_illegal_character:
      summary: campaign_component_name_contains_illegal_character
      value:
        code: campaign_component_name_contains_illegal_character
        http_status_code: 400
        message: >-
          Campaign component name can only contain alphanumeric, dash and
          underscore characters
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_component_name_out_of_range:
      summary: campaign_component_name_out_of_range
      value:
        code: campaign_component_name_out_of_range
        http_status_code: 400
        message: Campaign component name length is out of range
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_component_type_validation_failed:
      summary: campaign_component_type_validation_failed
      value:
        code: campaign_component_type_validation_failed
        http_status_code: 400
        message: Campaign component type validation failed
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    circular_component_reference:
      summary: circular_component_reference
      value:
        code: circular_component_reference
        http_status_code: 400
        message: Circular campaign component reference is not allowed
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    client_key_name_already_in_use:
      summary: client_key_name_already_in_use
      value:
        code: client_key_name_already_in_use
        http_status_code: 400
        message: Client key name is already used by another client key
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    component_facets_not_found:
      summary: component_facets_not_found
      value:
        code: component_facets_not_found
        http_status_code: 400
        message: Component facets not found
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    component_ids_and_references_both_provided:
      summary: component_ids_and_references_both_provided
      value:
        code: component_ids_and_references_both_provided
        http_status_code: 400
        message: Only one of componentIds or componentReferences may be provided
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    component_operation_name_already_in_use:
      summary: component_operation_name_already_in_use
      value:
        code: component_operation_name_already_in_use
        http_status_code: 400
        message: >-
          Component operation name is already used by another operation on this
          component
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    component_operation_name_contains_illegal_character:
      summary: component_operation_name_contains_illegal_character
      value:
        code: component_operation_name_contains_illegal_character
        http_status_code: 400
        message: >-
          Component operation name can only contain lowercase alphanumeric, dash
          and underscore characters
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    component_operation_name_missing:
      summary: component_operation_name_missing
      value:
        code: component_operation_name_missing
        http_status_code: 400
        message: Component operation name is missing
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    component_operation_name_out_of_range:
      summary: component_operation_name_out_of_range
      value:
        code: component_operation_name_out_of_range
        http_status_code: 400
        message: Component operation name length is out of range
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    component_operation_name_reserved:
      summary: component_operation_name_reserved
      value:
        code: component_operation_name_reserved
        http_status_code: 400
        message: Component operation name is a reserved keyword
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    excessive_component_reference:
      summary: excessive_component_reference
      value:
        code: excessive_component_reference
        http_status_code: 400
        message: Root campaign component may have at most one reference
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    external_element_is_referenced_by_active_configuration:
      summary: external_element_is_referenced_by_active_configuration
      value:
        code: external_element_is_referenced_by_active_configuration
        http_status_code: 400
        message: External element is referenced by active configuration
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    external_elements_cannot_have_multiple_references:
      summary: external_elements_cannot_have_multiple_references
      value:
        code: external_elements_cannot_have_multiple_references
        http_status_code: 400
        message: External elements cannot have multiple references
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    file_name_matches_match_type_required:
      summary: file_name_matches_match_type_required
      value:
        code: file_name_matches_match_type_required
        http_status_code: 400
        message: File name matches trigger requires a match type
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    file_name_matches_pattern_invalid_regex:
      summary: file_name_matches_pattern_invalid_regex
      value:
        code: file_name_matches_pattern_invalid_regex
        http_status_code: 400
        message: File name matches trigger pattern is not a valid regular expression
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    file_name_matches_pattern_required:
      summary: file_name_matches_pattern_required
      value:
        code: file_name_matches_pattern_required
        http_status_code: 400
        message: File name matches trigger requires a pattern
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_component_installed_into_socket:
      summary: invalid_component_installed_into_socket
      value:
        code: invalid_component_installed_into_socket
        http_status_code: 400
        message: Invalid component installed into socket
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_component_reference:
      summary: invalid_component_reference
      value:
        code: invalid_component_reference
        http_status_code: 400
        message: Unknown referenced campaign component
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_component_reference_socket_name:
      summary: invalid_component_reference_socket_name
      value:
        code: invalid_component_reference_socket_name
        http_status_code: 400
        message: Invalid component reference socket name
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_external_component_reference:
      summary: invalid_external_component_reference
      value:
        code: invalid_external_component_reference
        http_status_code: 400
        message: Unknown external referenced campaign component
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_json:
      summary: invalid_json
      value:
        code: invalid_json
        http_status_code: 400
        message: JSON is invalid
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_null:
      summary: invalid_null
      value:
        code: invalid_null
        http_status_code: 400
        message: The attribute may be omitted but not nullified
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_parameter:
      summary: invalid_parameter
      value:
        code: invalid_parameter
        http_status_code: 400
        message: Parameter is invalid.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    lands_in_directory_path_required:
      summary: lands_in_directory_path_required
      value:
        code: lands_in_directory_path_required
        http_status_code: 400
        message: Lands in directory trigger requires a directory path
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    missing_request_body:
      summary: missing_request_body
      value:
        code: missing_request_body
        http_status_code: 400
        message: Missing request body
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    orphan_external_component_reference:
      summary: orphan_external_component_reference
      value:
        code: orphan_external_component_reference
        http_status_code: 400
        message: Orphan external referenced campaign component
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    redundant_component_reference:
      summary: redundant_component_reference
      value:
        code: redundant_component_reference
        http_status_code: 400
        message: Same reference defined multiple times
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    self_component_reference:
      summary: self_component_reference
      value:
        code: self_component_reference
        http_status_code: 400
        message: Self campaign component reference is not allowed
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    trigger_evaluation_failed:
      summary: trigger_evaluation_failed
      value:
        code: trigger_evaluation_failed
        http_status_code: 400
        message: A buildtime expression on the trigger could not be evaluated
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    trigger_parent_job_id_mismatch:
      summary: trigger_parent_job_id_mismatch
      value:
        code: trigger_parent_job_id_mismatch
        http_status_code: 400
        message: >-
          The parent_job_id resolves to a different job than the one in the
          request path
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    trigger_type_mismatch:
      summary: trigger_type_mismatch
      value:
        code: trigger_type_mismatch
        http_status_code: 400
        message: Trigger type does not match the stored trigger
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    trigger_type_required:
      summary: trigger_type_required
      value:
        code: trigger_type_required
        http_status_code: 400
        message: Trigger type is required
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    method_unauthorized:
      summary: method_unauthorized
      value:
        code: method_unauthorized
        http_status_code: 401
        message: Unauthorized access to this endpoint
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    payment_required:
      summary: payment_required
      value:
        code: payment_required
        http_status_code: 402
        message: The access_token provided is associated with an unpaid account.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    access_denied:
      summary: access_denied
      value:
        code: access_denied
        http_status_code: 403
        message: >-
          The access_token provided is not permitted to access the specified
          resource.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    missing_access_token:
      summary: missing_access_token
      value:
        code: missing_access_token
        http_status_code: 403
        message: No access_token was provided with this request.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    unsupported_media_type:
      summary: unsupported_media_type
      value:
        code: unsupported_media_type
        http_status_code: 415
        message: Request had an unsupported or no media type
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    too_many_requests:
      summary: too_many_requests
      value:
        code: too_many_requests
        http_status_code: 429
        message: >-
          The server is unable to process your request at the moment, please
          retry later.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
  securitySchemes:
    HEADER:
      in: header
      name: Authorization
      type: apiKey
      x-bearer-format: bearer
    QUERY:
      in: query
      name: access_token
      type: apiKey
    COOKIE:
      in: cookie
      name: extole_token
      type: apiKey

````